> ## Documentation Index
> Fetch the complete documentation index at: https://docs.nx1cloud.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Schedule query

> Schedule a query to run on a cron schedule. Returns flow detail.



## OpenAPI

````yaml post /api/dataeng/schedule
openapi: 3.1.0
info:
  title: Nx1 AI API
  description: |

    AI API for Nx1 Data Platform Management and Automated Data Tasks.

    Authentication is required via PSK in Authorization header.

    Default PSK is | [ask a friend] |
  version: 0.10.2
servers: []
security: []
paths:
  /api/dataeng/schedule:
    post:
      tags:
        - Data engineering
      summary: Schedule query
      description: Schedule a query to run on a cron schedule. Returns flow detail.
      operationId: schedule_query_api_dataeng_schedule_post
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/ScheduleDataEngRequest'
        required: true
      responses:
        '200':
          description: Schedule query successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ScheduleResponse'
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
          description: Bad Request
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - OAuth2AuthorizationCodeBearer: []
        - APIKeyHeader: []
components:
  schemas:
    ScheduleDataEngRequest:
      properties:
        query_id:
          anyOf:
            - type: string
              format: uuid
            - type: 'null'
          title: Query Id
          description: A unique ID of the already generated query.
        mode:
          type: string
          title: Mode
          description: >-
            Defines how the job writes query output to the target table. Valid
            values: `append`, `overwrite`, or `merge`.
        merge_columns:
          anyOf:
            - type: string
            - type: 'null'
          title: Merge Columns
          description: >-
            Columns used to match and merge data. Specify only if `mode` is
            `merge`.
        schedule:
          anyOf:
            - type: string
            - type: 'null'
          title: Schedule
          description: A cron expression specifying when or how often the query runs.
        table:
          type: string
          title: Table
          description: The target table where the job stores results.
        schema_name:
          type: string
          title: Schema Name
          description: The schema containing the target table.
        owner_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Owner Id
          description: The logged in user's email ID.
        domain:
          anyOf:
            - type: string
            - type: 'null'
          title: Domain
          description: The domain to assign to the dataset in DataHub.
        tags:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Tags
          description: Tags to assign to the dataset in DataHub.
      type: object
      required:
        - mode
        - table
        - schema_name
      title: ScheduleDataEngRequest
    ScheduleResponse:
      properties:
        id:
          anyOf:
            - type: string
              format: uuid
            - type: 'null'
          title: Id
          description: A unique ID for the scheduled query flow.
        flow_url:
          type: string
          title: Flow Url
          description: Airflow URL to access the scheduled query flow.
        error:
          anyOf:
            - type: string
            - type: 'null'
          title: Error
          description: Error message if scheduling fails due to any issue.
      type: object
      required:
        - flow_url
      title: ScheduleResponse
    ErrorResponse:
      properties:
        error:
          type: string
          title: Error
          description: A brief description of the error that occurred.
        code:
          type: integer
          title: Code
          description: The HTTP status code associated with the error.
          default: 500
      type: object
      required:
        - error
      title: ErrorResponse
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
        input:
          title: Input
        ctx:
          type: object
          title: Context
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    OAuth2AuthorizationCodeBearer:
      type: oauth2
      flows:
        authorizationCode:
          scopes: {}
          authorizationUrl: >-
            https://sso-rapid.rapid.nx1cloud.com/realms/rapid/protocol/openid-connect/auth
          tokenUrl: >-
            https://sso-rapid.rapid.nx1cloud.com/realms/rapid/protocol/openid-connect/token
    APIKeyHeader:
      type: apiKey
      in: header
      name: Authorization-PSK

````